//
//  ViewController.swift
//  DeviceControlSample1
//
//  Created by driver on 2018/08/07.
//  Copyright © 2018 CITIZEN SYSTEMS. All rights reserved.
//

import UIKit
import CSJPOSLibSwift

class ViewController: UIViewController, UITextFieldDelegate, ScannerEventDelegate {
    
    @IBOutlet weak var segmentPortType: UISegmentedControl!
    @IBOutlet weak var editText_Address_Wifi: UITextField!
    @IBOutlet weak var editText_PrinterPort: UITextField!
    @IBOutlet weak var editText_DisplayAddress: UITextField!
    @IBOutlet weak var editText_DisplayPort: UITextField!
    @IBOutlet weak var editText_ScannerAddress: UITextField!
    @IBOutlet weak var editText_ScannerPort: UITextField!
    @IBOutlet weak var lavel_ScannerStatus: UITextField!
    
    var scanner: CSJPOSLibSwift.Scanner?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        editText_Address_Wifi.returnKeyType = UIReturnKeyType.done
        editText_Address_Wifi.delegate = self
        
        segmentPortType.selectedSegmentIndex = 0
        
        editText_Address_Wifi.text = ""
        
        editText_PrinterPort.returnKeyType = UIReturnKeyType.done
        editText_PrinterPort.delegate = self
        
        editText_DisplayAddress.returnKeyType = UIReturnKeyType.done
        editText_DisplayAddress.delegate = self
        editText_DisplayAddress.text = ""
        
        editText_DisplayPort.returnKeyType = UIReturnKeyType.done
        editText_DisplayPort.delegate = self
        
        editText_ScannerAddress.returnKeyType = UIReturnKeyType.done
        editText_ScannerAddress.delegate = self
        editText_ScannerAddress.text = ""
        
        editText_ScannerPort.returnKeyType = UIReturnKeyType.done
        editText_ScannerPort.delegate = self
        
        lavel_ScannerStatus.text = "Stopped"
        lavel_ScannerStatus.backgroundColor = UIColor.lightGray
        
        // Scanner class create
        scanner = CSJPOSLibSwift.Scanner()
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func messageBox(_ message: String, withTitle title: String, withAutoDismiss dismiss: Bool){
        let alert: UIAlertController = UIAlertController(title:title, message: message, preferredStyle:  UIAlertControllerStyle.alert)
        if dismiss == true {
            present(alert, animated: true, completion: {
                DispatchQueue.main.asyncAfter(deadline: .now() + 1.5, execute: {
                    alert.dismiss(animated: false, completion: nil)
                })
            })
        }
        else {
            let defaultAction: UIAlertAction = UIAlertAction(title: "OK", style: UIAlertActionStyle.default, handler:{
                (action: UIAlertAction!) -> Void in
                print("OK")
            })
            alert.addAction(defaultAction)
            present(alert, animated: true, completion: nil)
        }
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        editText_Address_Wifi.resignFirstResponder()
        editText_PrinterPort.resignFirstResponder()
        editText_DisplayAddress.resignFirstResponder()
        editText_DisplayPort.resignFirstResponder()
        editText_ScannerAddress.resignFirstResponder()
        editText_ScannerPort.resignFirstResponder()
        return true
    }
    
    @IBAction func onClick_button_Search(_ sender: Any) {
        var iftype:Int32 = 0
        var result: Int32 = 0
        var addressArray: Any = []
        var address_Array: [String] = []

        if segmentPortType.selectedSegmentIndex == 0 {
            iftype = ESCPOSConst.CMP_PORT_BLUETOOTH
        } else if segmentPortType.selectedSegmentIndex == 1 {
            iftype = ESCPOSConst.CMP_PORT_WiFi
        } else if segmentPortType.selectedSegmentIndex == 2 {
            iftype = ESCPOSConst.CMP_PORT_USB
        }

        addressArray = ESCPOSPrinter.searchESCPOSPrinter(iftype, withSearchTime: Int32(3), result: &result) as Any
        
        if (addressArray as AnyObject).count > 0 {
            for i in 0 ..< (addressArray as AnyObject).count {
                let obj = (addressArray as! NSArray)[i]
                address_Array.append(obj as! String)
            }
        }else{
            messageBox("Search Error : \(result)", withTitle: "0 Search Results", withAutoDismiss: true)
        }
        if address_Array.count > 0 {
            let alert: UIAlertController = UIAlertController(title:"Select the address", message: nil, preferredStyle:  UIAlertController.Style.alert)
            for i in 0 ..< address_Array.count {
                let defaultAction: UIAlertAction = UIAlertAction(title: address_Array[i], style: UIAlertAction.Style.default, handler:{
                    (action: UIAlertAction!) -> Void in
                    self.editText_Address_Wifi.text = address_Array[i]
                    self.editText_DisplayAddress.text = address_Array[i]
                    self.editText_ScannerAddress.text = address_Array[i]
                })
                alert.addAction(defaultAction)
            }
            present(alert, animated: true, completion: nil)
        }
    }
    
    @IBAction func onClick_button_SamplePrint01_Wifi(_ sender: Any) {
        var printer: ESCPOSPrinter? = CSJPOSLibSwift.ESCPOSPrinter()
        
        // get address
        let addr = editText_Address_Wifi.text
        let port: Int32? = Int32(editText_PrinterPort.text!)
        var iftype:Int32 = 0
        var result: Int32 = 0
        
        // connect
        if segmentPortType.selectedSegmentIndex == 0 {
            iftype = ESCPOSConst.CMP_PORT_BLUETOOTH
        } else if segmentPortType.selectedSegmentIndex == 1 {
            iftype = ESCPOSConst.CMP_PORT_WiFi
        } else if segmentPortType.selectedSegmentIndex == 2 {
            iftype = ESCPOSConst.CMP_PORT_USB
        }

        if port != nil {
            result = printer!.connect(iftype, withAddrress: addr, withPort: Int32(port!))
        }else{
            result = printer!.connect(iftype, withAddrress: addr)
        }
        
        if ESCPOSConst.CMP_SUCCESS == result {
            // character set
            _ = printer!.setEncoding(String.Encoding.isoLatin1)    // latin-1
            //printer!.setEncoding(NSISOLatin1StringEncoding)  // japanese shift-jis
            
            // start transaction (batch)
            _ = printer!.transactionPrint(CMP_TP_TRANSACTION)
            
            // print app name
            if let appName = Bundle.main.localizedInfoDictionary?["CFBundleDisplayName"] as? String {
                _ = printer!.printText("\(appName)\n\n", withAlignment:ESCPOSConst.CMP_ALIGNMENT_CENTER, withAttribute:ESCPOSConst.CMP_FNT_DEFAULT, withTextSize:ESCPOSConst.CMP_TXT_1WIDTH|CMP_TXT_1HEIGHT)
            }
            
            // printText
            _ = printer!.printText("- Sample Print 1 -\n", withAlignment:ESCPOSConst.CMP_ALIGNMENT_CENTER, withAttribute:ESCPOSConst.CMP_FNT_DEFAULT, withTextSize:ESCPOSConst.CMP_TXT_1WIDTH|ESCPOSConst.CMP_TXT_2HEIGHT)
            _ = printer!.printText("1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890\n", withAlignment:ESCPOSConst.CMP_ALIGNMENT_RIGHT, withAttribute:ESCPOSConst.CMP_FNT_DEFAULT, withTextSize:ESCPOSConst.CMP_TXT_1WIDTH|ESCPOSConst.CMP_TXT_1HEIGHT)
            
            //printQRCode
            _ = printer!.printQRCode("http://www.citizen-systems.co.jp", withModuleSize:6, withECLevel:ESCPOSConst.CMP_QRCODE_EC_LEVEL_L, withAlignment:ESCPOSConst.CMP_ALIGNMENT_RIGHT)
            
            // partical cut with pre-feed
            _ = printer!.cutPaper(ESCPOSConst.CMP_CUT_PARTIAL_PREFEED)
            
            // end transaction (batch)
            result = printer!.transactionPrint(ESCPOSConst.CMP_TP_NORMAL)
            
            // discoonect
            _ = printer!.disconnect()
            
            if result != ESCPOSConst.CMP_SUCCESS {
                messageBox("Transaction Error : \(result)", withTitle: "Error", withAutoDismiss: true)
            }
        } else {
            let exError = printer!.getErrorCodeExtended()
            messageBox("Connect Error : \(result)(\(exError))", withTitle: "Error", withAutoDismiss: true)
        }
        
        printer = nil
    }
    
    @IBAction func onClick_button_SamplePrint02_Wifi(_ sender: Any) {
        var printer: ESCPOSPrinter? = CSJPOSLibSwift.ESCPOSPrinter()
        
        // get address
        let addr = editText_Address_Wifi.text
        //let port: Int32 = Int32(editText_PrinterPort.text!)!
        let port: Int32? = Int32(editText_PrinterPort.text!)
        var iftype:Int32 = 0
        var result: Int32 = 0
        
        // connect
        if segmentPortType.selectedSegmentIndex == 0 {
            iftype = ESCPOSConst.CMP_PORT_BLUETOOTH
        } else if segmentPortType.selectedSegmentIndex == 1 {
            iftype = ESCPOSConst.CMP_PORT_WiFi
        } else if segmentPortType.selectedSegmentIndex == 2 {
            iftype = ESCPOSConst.CMP_PORT_USB
        }

        if port != nil {
            result = printer!.connect(iftype, withAddrress: addr, withPort: Int32(port!))
        }else{
            result = printer!.connect(iftype, withAddrress: addr)
        }
        
        if ESCPOSConst.CMP_SUCCESS == result {
            // character set
            _ = printer!.setEncoding(String.Encoding.isoLatin1)    // latin-1
            //posPtr!.setEncoding(NSISOLatin1StringEncoding)  // japanese shift-jis
            
            // start transaction (batch)
            _ = printer!.transactionPrint(ESCPOSConst.CMP_TP_TRANSACTION)
            
            // print app name
            if let appName = Bundle.main.localizedInfoDictionary?["CFBundleDisplayName"] as? String {
                _ = printer!.printText("\(appName)\n\n", withAlignment:ESCPOSConst.CMP_ALIGNMENT_CENTER, withAttribute:ESCPOSConst.CMP_FNT_DEFAULT, withTextSize:ESCPOSConst.CMP_TXT_1WIDTH|ESCPOSConst.CMP_TXT_1HEIGHT)
            }

            // printText
            let sample2 = String(format: "%c|2vC%c|cA- Sample Print 2 -\n", 27, 27)
            _ = printer!.printNormal(sample2)
            _ = printer!.printText("1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890\n", withAlignment:ESCPOSConst.CMP_ALIGNMENT_RIGHT, withAttribute:ESCPOSConst.CMP_FNT_DEFAULT, withTextSize:ESCPOSConst.CMP_TXT_1WIDTH|ESCPOSConst.CMP_TXT_1HEIGHT)
            
            // start page mode
            _ = printer!.pageModePrint(ESCPOSConst.CMP_PM_PAGE_MODE)
            
            // set offset value in pagemode
            _ = printer!.setPageModeVerticalPosition(0)
            _ = printer!.setPageModeHorizontalPosition(0)
            
            // set print direction in pagemode
            _ = printer!.setPageModePrintDirection(ESCPOSConst.CMP_PD_TOP_TO_BOTTOM)
            
            // set printable area in pagemode
            _ = printer!.setPageModePrintArea("500,0,76,800" )
            
            let receipt = String(format: "%c|4C- Receipt -\n", 27)
            _ = printer!.printNormal(receipt)
            _ = printer!.setPageModePrintArea("260,0,120,800")
            _ = printer!.printText("$ 299.99- \n", withAlignment:ESCPOSConst.CMP_ALIGNMENT_CENTER, withAttribute:ESCPOSConst.CMP_FNT_UNDERLINE|ESCPOSConst.CMP_FNT_BOLD, withTextSize:ESCPOSConst.CMP_TXT_4WIDTH|ESCPOSConst.CMP_TXT_4HEIGHT)
            _ = printer!.setPageModePrintArea("88,0,88,560")
            _ = printer!.printText(" CITIZEN SYSTEMS\n", withAlignment:ESCPOSConst.CMP_ALIGNMENT_RIGHT, withAttribute:CMP_FNT_DEFAULT, withTextSize:CMP_TXT_2WIDTH|CMP_TXT_3HEIGHT)
            //posPtr!.setPageModePrintArea: @"0,0,88,480")
            _ = printer!.setPageModePrintArea("0,0,98,480")
            _ = printer!.printBarCode("123456789012", withSymbology:ESCPOSConst.CMP_BCS_UPCA, withHeight: 64, withWidth:4, withAlignment:ESCPOSConst.CMP_ALIGNMENT_LEFT, withTextPosition:ESCPOSConst.CMP_HRI_TEXT_BELOW)
            _ = printer!.setPageModePrintArea("0,600,192,192")
            _ = printer!.printQRCode("http://www.citizen-systems.co.jp/", withModuleSize :5, withECLevel:ESCPOSConst.CMP_QRCODE_EC_LEVEL_L, withAlignment:ESCPOSConst.CMP_ALIGNMENT_LEFT)
            
            // end page mode
            _ = printer!.pageModePrint(ESCPOSConst.CMP_PM_NORMAL)
            
            // partical cut with pre-feed
            _ = printer!.cutPaper(ESCPOSConst.CMP_CUT_PARTIAL_PREFEED)
            
            // end transaction (batch)
            result = printer!.transactionPrint(ESCPOSConst.CMP_TP_NORMAL)
            
            // discoonect
            _ = printer!.disconnect()
            
            if result != ESCPOSConst.CMP_SUCCESS {
                messageBox("Transaction Error : \(result)", withTitle: "Error", withAutoDismiss: true)
            }
        } else {
            let exError = printer!.getErrorCodeExtended()
            messageBox("Connect Error : \(result)(\(exError))", withTitle: "Error", withAutoDismiss: true)
        }
        
        printer = nil
    }
    
    @IBAction func onClick_button_SampleDisplay1(_ sender: Any) {
        var result: Int32 = 0
        let display: LineDisplay? = CSJPOSLibSwift.LineDisplay()
        let addr = editText_DisplayAddress.text
        let port: Int32? = Int32(editText_DisplayPort.text!)
        var iftype:Int32 = 0
        
        // connect
        if segmentPortType.selectedSegmentIndex == 0 {
            iftype = LineDisplayConst.CDP_PORT_BLUETOOTH
        } else if segmentPortType.selectedSegmentIndex == 1 {
            iftype = LineDisplayConst.CDP_PORT_WiFi
        } else if segmentPortType.selectedSegmentIndex == 2 {
            iftype = LineDisplayConst.CDP_PORT_USB
        }

        if port != nil {
            result = display!.connect(iftype, withAddrress: addr, withPort: Int32(port!))
        }else{
            result = display!.connect(iftype, withAddrress: addr)
        }
        
        if LineDisplayConst.CDP_SUCCESS == result {
            _ = display!.clearDisplay(LineDisplayConst.CDP_AREA_ALL)
            _ = display!.displayText("New York steak", reverseFlag: true )
            _ = display!.moveCursor(-1, y: 1)
            result = display!.displayText("$89.99-")
            
            // discoonect
            _ = display!.disconnect()
            
            if result != LineDisplayConst.CDP_SUCCESS {
                messageBox("displayText Error : \(result)", withTitle: "Error", withAutoDismiss: true)
            }
        } else {
            let exError = display!.getErrorCodeExtended()
            messageBox("Connect Error : \(result)(\(exError))", withTitle: "Error", withAutoDismiss: true)
        }
    }
    
    @IBAction func onClick_button_SampleDisplay2(_ sender: Any) {
        var result: Int32 = 0
        let display: LineDisplay? = CSJPOSLibSwift.LineDisplay()
        let addr = editText_DisplayAddress.text
        let port: Int32? = Int32(editText_DisplayPort.text!)
        var iftype:Int32 = 0
        
        // connect
        if segmentPortType.selectedSegmentIndex == 0 {
            iftype = LineDisplayConst.CDP_PORT_BLUETOOTH
        } else if segmentPortType.selectedSegmentIndex == 1 {
            iftype = LineDisplayConst.CDP_PORT_WiFi
        } else if segmentPortType.selectedSegmentIndex == 2 {
            iftype = LineDisplayConst.CDP_PORT_USB
        }

        if port != nil {
            result = display!.connect(iftype, withAddrress: addr, withPort: Int32(port!))
        }else{
            result = display!.connect(iftype, withAddrress: addr)
        }
 
        if LineDisplayConst.CDP_SUCCESS == result {
            _ = display!.clearDisplay(LineDisplayConst.CDP_AREA_ALL)
            _ = display!.displayText("Thank you so much!")
            _ = display!.setCursorPosition(13, y: 2)
            result = display!.displayText("$299.99-" , reverseFlag: true)
            
            // discoonect
            _ = display!.disconnect()
            
            if result != LineDisplayConst.CDP_SUCCESS {
                messageBox("displayText Error : \(result)", withTitle: "Error", withAutoDismiss: true)
            }
            
        } else {
            let exError = display!.getErrorCodeExtended()
            messageBox("Connect Error : \(result)(\(exError))", withTitle: "Error", withAutoDismiss: true)
        }
    }
    
    @IBAction func onClick_button_Connect(_ sender: Any) {
        var result: Int32 = 0
        let addr = editText_ScannerAddress.text
        let port: Int32? = Int32(editText_ScannerPort.text!)
        var iftype:Int32 = 0
        
        // connect
        if segmentPortType.selectedSegmentIndex == 0 {
            iftype = ScannerConst.CSC_PORT_BLUETOOTH
        } else if segmentPortType.selectedSegmentIndex == 1 {
            iftype = ScannerConst.CSC_PORT_WiFi
        } else if segmentPortType.selectedSegmentIndex == 2 {
            iftype = ScannerConst.CSC_PORT_USB
        }

        if port != nil {
            result = scanner!.connect(iftype, withAddrress: addr, withPort: Int32(port!))
        }else{
            result = scanner!.connect(iftype, withAddrress: addr)
        }
        
        if ScannerConst.CSC_SUCCESS == result {
            // Status Update Event Callback setting
            _ = scanner!.setStatusUpdateEventCallback(self)
            _ = scanner!.setDataEventCallback(self)
            
        } else {
            let exError = scanner!.getErrorCodeExtended()
            messageBox("Connect Error : \(result)(\(exError))", withTitle: "Error", withAutoDismiss: true)
        }
    }
    
    @IBAction func onClick_button_Disconnect(_ sender: Any) {
        // Release callback
        _ = scanner!.setStatusUpdateEventCallback(nil)
        _ = scanner!.setDataEventCallback(nil)
        
        // discoonect
        _ = scanner!.disconnect()
        lavel_ScannerStatus.text = "Stopped"
        lavel_ScannerStatus.backgroundColor = UIColor.lightGray
    }
    
    func statusUpdateEventCallback(_ status: Int32) {
        
        if ScannerConst.CSC_SUE_POWER_ONLINE == status {
            lavel_ScannerStatus.text = "Online"
            lavel_ScannerStatus.backgroundColor = UIColor.init(red: 0.0/255.0, green: 255.0/255.0, blue: 0.0/255.0, alpha: 1.0)
        } else {
            lavel_ScannerStatus.text = "Offline"
            lavel_ScannerStatus.backgroundColor = UIColor.red
        }
    }
    
    func dataEventCallback(_ data: Data!) {
        messageBox(String(data: data, encoding: .utf8)!, withTitle: "Scan Data", withAutoDismiss: false)
    }
}
